import 'package:async_injector/error/not_have_dependency.dart';

class Scope {
  Map<String, dynamic> dependencies = {};
  Map<String, dynamic> buildDependencies = {};

  T get<T>() {
    T dependency;

    if (buildDependencies != null) {
      dependency = buildDependencies[T.toString()];
    }
    dependency ??= dependencies[T.toString()];

    if (dependency == null) {
      throw NotHaveDependency("not have ${T.toString()}");
    }

    return dependency;
  }

  add<T>(T dependency, {Type type}) {
    var key = type != null && type.toString() != dynamic.toString()
        ? type.toString()
        : createKey<T>(dependency);
    dependencies[key] = dependency;
  }

  addBuildDependencies<T>(T dependency) {
    var key = createKey<T>(dependency);
    buildDependencies[key] = dependency;
  }

  createKey<T>(T dependency) => T.toString() != dynamic.toString()
      ? T.toString()
      : dependency.runtimeType.toString();
}
